<?php

namespace Ulmus\Ldap\Common;

class PasswordHelper {

    public static function unicode(string $password) : string
    {
        return mb_convert_encoding("\"$password\"", "UTF-16LE");
    }

    public static function hashSHA(string $password) : string
    {
        return '{SHA}' .  base64_encode(sha1($password, true));
    }

    public static function hashSSHA(string $password) : string
    {
        $salt = static::salt();

        return '{SSHA}' . base64_encode(sha1($password . $salt, true) . $salt);
    }

    public static function hashMD5(string $password) : string
    {
        $salt = static::salt();

        $newmailbox["userpassword"] = "{MD5}" . base64_encode( sha1( $password . $salt, true) . $salt );
    }

    protected static function salt(int $length = 4, int $shuffle = 10) : string
    {
        return substr(str_shuffle(str_repeat('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789',$shuffle)),0,$length);
    }
}